import dayjs from "dayjs";
export declare enum CalendarTypeEnum {
    day = "day",
    workWeek = "workWeek",
    week = "week",
    agendum = "agendum"
}
interface Action {
    toggleCalendarType: (type: CalendarTypeEnum) => void;
    preCalendar: () => void;
    nextCalendar: () => void;
    setCurrentDay: (time: dayjs.Dayjs) => void;
    setColHeight: (h: number) => void;
}
export interface State {
    /**
     * 日历显示类型
     */
    CalendarType: CalendarTypeEnum;
    /**
     * 设置的时间
     */
    currentDay: dayjs.Dayjs;
    /**
     * 列高
     */
    colHeight: number;
}
export type BitzFuiCalendarStore = State & Action;
export declare const useBitzFuiCalendarStore: import("zustand").UseBoundStore<import("zustand").StoreApi<BitzFuiCalendarStore>>;
export default useBitzFuiCalendarStore;
