import { FC } from 'react';
import type { TableProps } from 'antd';
import './index.less';
type RecordType = any;
interface BitzTableProps extends TableProps<RecordType> {
    /**
     * PC端：是否显示分页
     */
    showPagination?: boolean;
    /**
     * PC端&移动端：后端返回的数组数据
     */
    dataSource?: any[];
    /**
     * PC端：分页总数
     */
    total?: number;
    /**
     * PC端&移动端：自定义的列表参数
     */
    columns?: any;
    /**
     * PC端&移动端：操作按钮数组
     */
    operations?: any;
    /**
     * PC端：表格行key的取值
     */
    rowKey?: string;
    /**
     * PC&移动端：请求加载状态
     */
    loading?: boolean;
    /**
     * PC&移动端:操作按钮返回函数
     */
    tableOperationEmit?: (type: string, item: any) => void;
    /**
     * PC端：给父组件传值 page当前第几页  pageSize每页有多少
     */
    paginationEmit?: (page: number, pageSize: number) => void;
    /**
     * 移动端：加载更多返回函数
     */
    mobileLoadEmit?: () => void;
    /**
     * 移动端：下拉刷新
     */
    mobileRefreshEmit?: () => void;
    /**
     * 移动端：列表数据回显
     */
    tableItemEmit?: (val: any) => void;
    /**
     * 移动端：页面高度，关系到上拉刷新
     */
    mobilePageHeight?: number;
    /**
     * 移动端：取消按钮名字
     */
    mobileCancelText?: string;
}
declare const BitzTable: FC<BitzTableProps>;
export default BitzTable;
